

import java.util.Calendar;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class QueuePopulator {

	private static Session session = null;
	private static MessageProducer messageProducer = null;

	public QueuePopulator() throws Exception {
		/*
		 * Create a JNDI API InitialContext object if none exists yet.
		 */
		Context jndiContext = null;

		try {
			jndiContext = new InitialContext();
		} catch (NamingException ex) {
			throw new Exception("Error loading Initial Context",
					ex);
		}
		/*
		 * Look up connection factory and destination. If either does not exist,
		 * exit. If you look up a TopicConnectionFactory or a
		 * QueueConnectionFactory, program behavior is the same.
		 */
		ConnectionFactory connectionFactory = null;
		Destination dest = null;
		Connection connection = null;

		try {
			connectionFactory = (ConnectionFactory) jndiContext
					.lookup("java:/JmsXA");
			dest = (Destination) jndiContext.lookup("/queue/testQ");
			connection = connectionFactory.createConnection();
			session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
			messageProducer = session.createProducer(dest);
			messageProducer.setDisableMessageID(true);
			messageProducer.setDisableMessageTimestamp(true);
		} catch (Exception ex) {
			try {
				if (messageProducer != null) {
					messageProducer.close();
				}
				if (session != null) {
					session.close();
				}
				if (connection != null) {
					connection.close();
				}
			} catch (JMSException exception) {
				exception.printStackTrace();
			}
			throw new Exception(
					"Error while connecting to Queue", ex);
		}
	}

	/**
	 * This method will send a message to the queue.
	 *
	 * @param message
	 */
	public void sendMessagetoQ(String message) {
		TextMessage textMessage;
		try {
			textMessage = session.createTextMessage();
			textMessage.setText(message);
			long startTime = Calendar.getInstance().getTimeInMillis();
			messageProducer.send(textMessage);
			System.out.println("time taken - "+ (Calendar.getInstance().getTimeInMillis() - startTime));
		} catch (JMSException ex) {
			// Log an error and ignore the message.
			ex.printStackTrace();
		}
	}

}
